#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library for ST7735
// #include <Adafruit_ST7789.h> // Hardware-specific library for ST7789
#include <SPI.h>

//#include <PololuLedStrip.h>

// Create an ledStrip object and specify the pin it will use.
//PololuLedStrip<2> ledStrip;

// Create a buffer for holding the colors (3 bytes per color).
//#define LED_COUNT 1
//rgb_color colors[LED_COUNT];

// For the breakout, you can use any 2 or 3 pins
// These pins will also work for the 1.8" TFT shield
#define TFT_CS     10
#define TFT_RST    9  // you can also connect this to the Arduino reset
                       // in which case, set this #define pin to -1!
#define TFT_DC     8
#define DN1 300
#define DN2 400
#define OK1 150
#define OK2 250
#define UP1 20
#define UP2 120     
// Option 1 (recommended): must use the hardware SPI pins
// (for UNO thats sclk = 13 and sid = 11) and pin 10 must be
// an output. This is much faster - also required if you want
// to use the microSD card (see the image drawing example)
//Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);
// Option 2: use any pins but a little slower!
#define TFT_SCLK 13   // set these to be whatever pins you like!
#define TFT_MOSI 11   // set these to be whatever pins you like!
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_MOSI, TFT_SCLK, TFT_RST);
#define INP 17 //PIN FOR BUTTONS

int oldx=0;
float r1=0;
float r2=0;
float spd=1; //скорость мяча
byte rsize1=20; //высота ракетки 1
byte rsize2=20; //высота ракетки 2
byte rsize22=20; //высота ракетки 2 по умолчанию
byte yr1=(128-rsize1)/2; //начальное положение 1 ракетки по y
byte yr2=(128-rsize2)/2; //начальное положение 2 ракетки по y
float xx=4; //начальная позиция мяча x
float yy=(yr2-rsize2/2); //начальная позиция мяча y
byte xr1=0; //начальное положение 1 ракетки по x
byte xr2=tft.width()-4; //начальное положение 2 ракетки по x
bool xvect=true; //true-мяч летит слева направо, false-мяч летит справа налево
bool yvect=true; //true-мяч летит сверху вниз, false-мяч летит снизу вверх
float ugol=1; 
byte sc1=0; //счет игрока 1
byte sc2=0; //счет игрока 2
bool ai1=true; //включить AI за красных
bool ai2=true; //включить AI за зеленых
bool ctr1=true; //включить управление AI за красных
bool ctr2=true; //включить управление AI за зеленых
byte level=1;
void setup(void) {
pinMode(INP,INPUT_PULLUP);
int x=analogRead(INP);
if((x>UP1)&&(x<UP2)) {
//up
rsize2=26;
rsize1=26;
rsize22=26;
level=2;
}
    
if((x>OK1)&&(x<OK2)) {
//OK
rsize2=32;
rsize1=32;
rsize22=32;
level=3;  
}
if((x>DN1)&&(x<DN2)) {
//down
rsize2=36;
rsize1=36;
rsize22=36;
level=4;
}
  tone(6, 500, 100);
  delay(100);
  tone(6, 1000, 100);
  delay(100);
  tone(6, 2000, 100);
  delay(100);
  noTone(6);
tft.initR(INITR_144GREENTAB);   // initialize a ST7735S chip, black tab
clearrect(0,128);
tft.setTextColor(ST77XX_WHITE);
  tft.setCursor(16, 44);
  tft.setTextSize(4);
  tft.print("PONG");
  tft.setTextColor(ST77XX_YELLOW);
  tft.setCursor(22, 84);
  tft.setTextSize(2);
  tft.print("LEVEL ");
  tft.print(level);
  delay(1000);
  tft.setTextColor(ST77XX_YELLOW);
  tft.setCursor(16, 44);
  tft.setTextSize(4);
  tft.print("PONG");
   tft.setTextColor(ST77XX_GREEN);
  tft.setCursor(16, 44);
  tft.setTextSize(4);
  tft.print("PONG");
  tft.setTextColor(ST77XX_BLUE);
  tft.setCursor(16, 44);
  tft.setTextSize(4);
  tft.print("PONG");
  tft.setTextColor(ST77XX_BLACK);
  tft.setCursor(16, 44);
  tft.setTextSize(4);
  tft.print("PONG");
  tft.setTextColor(ST77XX_BLACK);
  tft.setCursor(22, 84);
  tft.setTextSize(2);
  tft.print("LEVEL ");
  tft.print(level);
  tone(6, 2000, 100);
  delay(100);
  tone(6, 1000, 100);
  delay(100);
  tone(6, 500, 100);
  delay(100);
  noTone(6);
 tft.fillRect(xr1, yr1, 4, rsize1, ST77XX_RED);
 tft.fillRect(xr2, yr2, 4, rsize2, ST77XX_GREEN); 
score();
}
void loop() {
  int x=analogRead(INP);
  int clr=ST77XX_RED;
  if((ai1==true)&&(ctr1==true)) {if ((yr1+rsize1/2)>yy) { r1=-2;} else  { r1=2;} }
  if((ai2==true)&&(ctr2==true)) {if ((yr2+rsize2/2)>yy) { r2=-2;} else  { r2=2;} }
  if((x!=oldx)&&(x<500)) {
  
  if((x>UP1)&&(x<UP2)) {
  //up
  if(ai1==false) {r1=-2;}
  if(ai2==false) {r2=-4;} 
    }
    
    if((x>OK1)&&(x<OK2)) {
  //OK 
  if(ai2==false) {tone(6, 600, 100);
delay(100);
tone(6, 300, 100);
delay(100);
tone(6, 100, 100);
ai2=true; 
} else {
  tone(6, 100, 100);
delay(100);
tone(6, 300, 100);
delay(100);
tone(6, 600, 100);
ai2=false;}
delay(300);
    }
     if((x>DN1)&&(x<DN2)) {
  //down
  if(ai1==false) {r1=2;} 
  if(ai2==false) {r2=4;} 
    }
    }
if(r2!=0) {
yr2=yr2+r2;
if((abs(yr2)<=0)||(yr2>200)) {yr2=0; } else { 
if(yr2>(128-rsize2)) {yr2=(128-rsize2);}
 }
 
 } 
if(r1!=0) {
 yr1=yr1+r1;
 if(abs(yr1<=0)||(yr1>200))  {yr1=0;} else {
 if(yr1>=(128-rsize1)) {yr1=(128-rsize1);}
 }
 
 }
tft.fillRect(xr2, (yr2-6), 4, 6, ST77XX_BLACK);tft.fillRect(xr2, (yr2+rsize2), 4, 6, ST77XX_BLACK);
tft.fillRect(xr2, yr2, 4, rsize2, ST77XX_GREEN); 
if(ai2==true) {tft.fillRect(xr2, (yr2+(rsize2/2-2)), 4, 4, ST77XX_BLUE); } 
tft.fillRect(xr1, (yr1-6), 4, 6, ST77XX_BLACK);tft.fillRect(xr1, (yr1+rsize1), 4, 6, ST77XX_BLACK);
tft.fillRect(xr1, yr1, 4, rsize1, ST77XX_RED); 
if(ai1==true) {tft.fillRect(xr1, (yr1+(rsize1/2-2)), 4, 4, ST77XX_BLUE); } 
 
 
 r1=0;
 r2=0;
  
tft.fillRect(xx, yy, 4, 4, ST77XX_BLACK);  
if(xvect==true) {xx+=spd; if (xx>=120) { 
tft.setTextColor(ST77XX_BLACK);
  tft.setCursor(30, 5);
  tft.setTextSize(2);
  if(sc1<10) {tft.print(0);}
  tft.print(sc1);
if((yy>=yr2)&&(yy<=(yr2+rsize2))){
if(yy<=(yr2+rsize2/2)){ yvect=false; } else { yvect=true;} 
ugol=0.1+ abs((yr2+rsize2/2)-yy)/4+random(2,10)/10.0;   
tone(6, 100, 5);
spd+=0.2; 
if(sc2<sc1) { rsize2+=spd; } 
if(sc1<sc2) { rsize1+=spd; } 
} else {
tft.invertDisplay(true);
tone(6, 600, 100);
delay(100);
tone(6, 300, 100);
delay(100);
tone(6, 100, 100);
spd=1;
rsize2=rsize22;
rsize1=rsize22;
ugol=1;
tft.invertDisplay(false);
tft.fillRect(0, 0, 4, 128, ST77XX_BLACK);
tft.fillRect(124, 0, 4, 128, ST77XX_BLACK);
if(random(1,10)==5) {
rsize2+=10;
tft.fillRect(xr2, yr2, 4, rsize2, ST77XX_GREEN);
tone(6, 2000, 10);
delay(10);
rsize2+=10;
tft.fillRect(xr2, yr2, 4, rsize2, ST77XX_GREEN);
tone(6, 2000, 10);
delay(10);
rsize2+=10;
tft.fillRect(xr2, yr2, 4, rsize2, ST77XX_GREEN);
tone(6, 2000, 10);
delay(10);
rsize2+=10;
tft.fillRect(xr2, yr2, 4, rsize2, ST77XX_GREEN);
tone(6, 2000, 10);
delay(10);
rsize2+=10;
tft.fillRect(xr2, yr2, 4, rsize2, ST77XX_GREEN);
tone(6, 2000, 10);
delay(10);
}
sc1++;
} 
ctr1=true; ctr2=false;
score();
xvect=false; xx=120;}} else {
if(xvect==false) {xx-=spd; if (xx<=4) {
tft.setTextColor(ST77XX_BLACK);
  tft.setCursor(76,5);
  tft.setTextSize(2);
  if(sc2<10) {tft.print(0);}
  tft.print(sc2); 
if((yy>=yr1)&&(yy<=(yr1+rsize1))){ 
if(yy<=(yr1+rsize1/2)){ yvect=false; } else { yvect=true;}
ugol=0.1+abs((yr1+rsize1/2)-yy)/4+random(2,10)/10.0;   
tone(6, 100, 5); 

spd+=0.2;
if(sc2<sc1) { rsize2+=spd; } 
if(sc1<sc2) { rsize1+=spd; } 
} else {
tft.invertDisplay(true);
tone(6, 600, 100);
delay(100);
tone(6, 300, 100);
delay(100);
tone(6, 100, 100);
ugol=1;
spd=1;
rsize2=rsize22;
rsize1=rsize22;

tft.invertDisplay(false);
tft.fillRect(0, 0, 4, 128, ST77XX_BLACK);
tft.fillRect(124, 0, 4, 128, ST77XX_BLACK);
if(random(1,10)==5) {
rsize1+=10;
tft.fillRect(xr1, yr1, 4, rsize1, ST77XX_GREEN);
tone(6, 2000, 10);
delay(10);
rsize1+=10;
tft.fillRect(xr1, yr1, 4, rsize1, ST77XX_GREEN);
tone(6, 2000, 10);
delay(10);
rsize1+=10;
tft.fillRect(xr1, yr1, 4, rsize1, ST77XX_GREEN);
tone(6, 2000, 00);
delay(10);
rsize1+=10;
tft.fillRect(xr1, yr1, 4, rsize1, ST77XX_GREEN);
tone(6, 2000, 10);
delay(10);
rsize1+=10;
tft.fillRect(xr1, yr1, 4, rsize1, ST77XX_GREEN);
tone(6, 2000, 10);
delay(10);
}
sc2++;
}
ctr1=false; ctr2=true;
score();
xvect=true; xx=4; 
}}}
if(yvect==true) {yy+=ugol; if (yy>=126) {  tone(6, 2000, 5);  yvect=false; yy=126; }} else {
if(yvect==false) {yy-=ugol; if (yy<=4) { tone(6, 2000, 5);  yvect=true; yy=4; }}}
if(spd<=1) { spd=1; }
if(spd>20) { ugol=1; spd=20;}
tft.fillRect(xx, yy, 4, 4, ST77XX_WHITE); 
}
void clearrect(byte y1, byte y2) {
  for (int16_t y=y1; y < y2; y+=8) {
    tft.drawFastHLine(0, y, tft.width(), ST77XX_BLACK);
    tft.drawFastHLine(0, (y+1), tft.width(), ST77XX_BLACK);
    tft.drawFastHLine(0, (y+2), tft.width(), ST77XX_BLACK);
    tft.drawFastHLine(0, (y+3), tft.width(), ST77XX_BLACK);
  }
  for (int16_t y=(y1+4); y < y2; y+=8) {
    tft.drawFastHLine(0, y, tft.width(), ST77XX_BLACK);
    tft.drawFastHLine(0, (y+1), tft.width(), ST77XX_BLACK);
    tft.drawFastHLine(0, (y+2), tft.width(), ST77XX_BLACK);
    tft.drawFastHLine(0, (y+3), tft.width(), ST77XX_BLACK);
  }
}
void score() {
 tft.setTextColor(ST77XX_RED);
tft.setCursor(30, 5);
  tft.setTextSize(2);
  if(sc1<10) {tft.print(0);}
  tft.print(sc1);
  for (int16_t y=0; y < 128; y+=16) {
  tft.drawFastVLine(64, y, 8, ST77XX_YELLOW);
  }
  tft.setTextColor(ST77XX_GREEN);
tft.setCursor(76, 5);
  tft.setTextSize(2);
  if(sc2<10) {tft.print(0);}
  tft.print(sc2);
}

